package org.wfc.omada.api.sitesetting.model;

import com.fasterxml.jackson.annotation.JsonProperty;
import io.swagger.annotations.ApiModelProperty;

import javax.validation.Valid;
import javax.validation.constraints.NotNull;
import javax.validation.constraints.Pattern;
import java.util.Objects;

/**
 * SslVpnServerConfigOpenApiVo
 */
@javax.annotation.Generated(value = "org.openapitools.codegen.languages.SpringCodegen", date = "2024-12-04T11:32:19.054+08:00[Asia/Shanghai]")

public class SslVpnServerConfigOpenApiVo   {
  @JsonProperty("status")
  private Boolean status;

  @JsonProperty("wanPort")
  private String wanPort;

  @JsonProperty("ipPoolStart")
  private String ipPoolStart;

  @JsonProperty("ipPoolEnd")
  private String ipPoolEnd;

  @JsonProperty("primaryDns")
  private String primaryDns;

  @JsonProperty("secondaryDns")
  private String secondaryDns;

  @JsonProperty("servicePort")
  private Integer servicePort;

  @JsonProperty("authType")
  private Integer authType;

  @JsonProperty("radiusSetting")
  private RadiusSettingOpenApiVo radiusSetting;

  @JsonProperty("LDAPSetting")
  private LdapSettingOpenApiVo ldAPSetting;

  @JsonProperty("nameLockSetting")
  private LockSettingOpenApiVo nameLockSetting;

  @JsonProperty("ipLockSetting")
  private LockSettingOpenApiVo ipLockSetting;

  @JsonProperty("exitAtIdle")
  private Boolean exitAtIdle;

  @JsonProperty("exitTime")
  private Integer exitTime;

  @JsonProperty("totalTraffic")
  private Boolean totalTraffic;

  public SslVpnServerConfigOpenApiVo status(Boolean status) {
    this.status = status;
    return this;
  }

  /**
   * Status of the SSL VPN server.
   * @return status
  */
  @ApiModelProperty(required = true, value = "Status of the SSL VPN server.")
  @NotNull


  public Boolean getStatus() {
    return status;
  }

  public void setStatus(Boolean status) {
    this.status = status;
  }

  public SslVpnServerConfigOpenApiVo wanPort(String wanPort) {
    this.wanPort = wanPort;
    return this;
  }

  /**
   * WAN port ID of the SSL VPN server. It is required when parameter [status] is true. WAN port ID can be obtained from 'Get internet basic info' interface
   * @return wanPort
  */
  @ApiModelProperty(value = "WAN port ID of the SSL VPN server. It is required when parameter [status] is true. WAN port ID can be obtained from 'Get internet basic info' interface")


  public String getWanPort() {
    return wanPort;
  }

  public void setWanPort(String wanPort) {
    this.wanPort = wanPort;
  }

  public SslVpnServerConfigOpenApiVo ipPoolStart(String ipPoolStart) {
    this.ipPoolStart = ipPoolStart;
    return this;
  }

  /**
   * The start IP of the IP pool. It is required when parameter [status] is true.
   * @return ipPoolStart
  */
  @ApiModelProperty(value = "The start IP of the IP pool. It is required when parameter [status] is true.")

@Pattern(regexp="\\b((?!\\d\\d\\d)\\d+|1\\d\\d|2[0-4]\\d|25[0-5])\\.((?!\\d\\d\\d)\\d+|1\\d\\d|2[0-4]\\d|25[0-5])\\.((?!\\d\\d\\d)\\d+|1\\d\\d|2[0-4]\\d|25[0-5])\\.((?!\\d\\d\\d)\\d+|1\\d\\d|2[0-4]\\d|25[0-5])\\b") 
  public String getIpPoolStart() {
    return ipPoolStart;
  }

  public void setIpPoolStart(String ipPoolStart) {
    this.ipPoolStart = ipPoolStart;
  }

  public SslVpnServerConfigOpenApiVo ipPoolEnd(String ipPoolEnd) {
    this.ipPoolEnd = ipPoolEnd;
    return this;
  }

  /**
   * The end IP of the IP pool. It is required when parameter [status] is true.
   * @return ipPoolEnd
  */
  @ApiModelProperty(value = "The end IP of the IP pool. It is required when parameter [status] is true.")

@Pattern(regexp="\\b((?!\\d\\d\\d)\\d+|1\\d\\d|2[0-4]\\d|25[0-5])\\.((?!\\d\\d\\d)\\d+|1\\d\\d|2[0-4]\\d|25[0-5])\\.((?!\\d\\d\\d)\\d+|1\\d\\d|2[0-4]\\d|25[0-5])\\.((?!\\d\\d\\d)\\d+|1\\d\\d|2[0-4]\\d|25[0-5])\\b") 
  public String getIpPoolEnd() {
    return ipPoolEnd;
  }

  public void setIpPoolEnd(String ipPoolEnd) {
    this.ipPoolEnd = ipPoolEnd;
  }

  public SslVpnServerConfigOpenApiVo primaryDns(String primaryDns) {
    this.primaryDns = primaryDns;
    return this;
  }

  /**
   * Primary DNS Server of the SSL VPN server. It is required when parameter [status] is true.
   * @return primaryDns
  */
  @ApiModelProperty(value = "Primary DNS Server of the SSL VPN server. It is required when parameter [status] is true.")

@Pattern(regexp="\\b((?!\\d\\d\\d)\\d+|1\\d\\d|2[0-4]\\d|25[0-5])\\.((?!\\d\\d\\d)\\d+|1\\d\\d|2[0-4]\\d|25[0-5])\\.((?!\\d\\d\\d)\\d+|1\\d\\d|2[0-4]\\d|25[0-5])\\.((?!\\d\\d\\d)\\d+|1\\d\\d|2[0-4]\\d|25[0-5])\\b") 
  public String getPrimaryDns() {
    return primaryDns;
  }

  public void setPrimaryDns(String primaryDns) {
    this.primaryDns = primaryDns;
  }

  public SslVpnServerConfigOpenApiVo secondaryDns(String secondaryDns) {
    this.secondaryDns = secondaryDns;
    return this;
  }

  /**
   * Secondary DNS Server of the SSL VPN server.
   * @return secondaryDns
  */
  @ApiModelProperty(value = "Secondary DNS Server of the SSL VPN server.")

@Pattern(regexp="\\b((?!\\d\\d\\d)\\d+|1\\d\\d|2[0-4]\\d|25[0-5])\\.((?!\\d\\d\\d)\\d+|1\\d\\d|2[0-4]\\d|25[0-5])\\.((?!\\d\\d\\d)\\d+|1\\d\\d|2[0-4]\\d|25[0-5])\\.((?!\\d\\d\\d)\\d+|1\\d\\d|2[0-4]\\d|25[0-5])\\b") 
  public String getSecondaryDns() {
    return secondaryDns;
  }

  public void setSecondaryDns(String secondaryDns) {
    this.secondaryDns = secondaryDns;
  }

  public SslVpnServerConfigOpenApiVo servicePort(Integer servicePort) {
    this.servicePort = servicePort;
    return this;
  }

  /**
   * Service port of the SSL VPN server. Default value is 1194. It is required when parameter [status] is true, and it should be within the range of 1–65535
   * @return servicePort
  */
  @ApiModelProperty(value = "Service port of the SSL VPN server. Default value is 1194. It is required when parameter [status] is true, and it should be within the range of 1–65535")


  public Integer getServicePort() {
    return servicePort;
  }

  public void setServicePort(Integer servicePort) {
    this.servicePort = servicePort;
  }

  public SslVpnServerConfigOpenApiVo authType(Integer authType) {
    this.authType = authType;
    return this;
  }

  /**
   * Authentication type of the SSL VPN server should be a value as follows: 0: local; 1: radius; 2: LDAP. It is required when parameter [status] is true.
   * @return authType
  */
  @ApiModelProperty(value = "Authentication type of the SSL VPN server should be a value as follows: 0: local; 1: radius; 2: LDAP. It is required when parameter [status] is true.")


  public Integer getAuthType() {
    return authType;
  }

  public void setAuthType(Integer authType) {
    this.authType = authType;
  }

  public SslVpnServerConfigOpenApiVo radiusSetting(RadiusSettingOpenApiVo radiusSetting) {
    this.radiusSetting = radiusSetting;
    return this;
  }

  /**
   * Get radiusSetting
   * @return radiusSetting
  */
  @ApiModelProperty(value = "")

  @Valid

  public RadiusSettingOpenApiVo getRadiusSetting() {
    return radiusSetting;
  }

  public void setRadiusSetting(RadiusSettingOpenApiVo radiusSetting) {
    this.radiusSetting = radiusSetting;
  }

  public SslVpnServerConfigOpenApiVo ldAPSetting(LdapSettingOpenApiVo ldAPSetting) {
    this.ldAPSetting = ldAPSetting;
    return this;
  }

  /**
   * Get ldAPSetting
   * @return ldAPSetting
  */
  @ApiModelProperty(value = "")

  @Valid

  public LdapSettingOpenApiVo getLdAPSetting() {
    return ldAPSetting;
  }

  public void setLdAPSetting(LdapSettingOpenApiVo ldAPSetting) {
    this.ldAPSetting = ldAPSetting;
  }

  public SslVpnServerConfigOpenApiVo nameLockSetting(LockSettingOpenApiVo nameLockSetting) {
    this.nameLockSetting = nameLockSetting;
    return this;
  }

  /**
   * Get nameLockSetting
   * @return nameLockSetting
  */
  @ApiModelProperty(value = "")

  @Valid

  public LockSettingOpenApiVo getNameLockSetting() {
    return nameLockSetting;
  }

  public void setNameLockSetting(LockSettingOpenApiVo nameLockSetting) {
    this.nameLockSetting = nameLockSetting;
  }

  public SslVpnServerConfigOpenApiVo ipLockSetting(LockSettingOpenApiVo ipLockSetting) {
    this.ipLockSetting = ipLockSetting;
    return this;
  }

  /**
   * Get ipLockSetting
   * @return ipLockSetting
  */
  @ApiModelProperty(value = "")

  @Valid

  public LockSettingOpenApiVo getIpLockSetting() {
    return ipLockSetting;
  }

  public void setIpLockSetting(LockSettingOpenApiVo ipLockSetting) {
    this.ipLockSetting = ipLockSetting;
  }

  public SslVpnServerConfigOpenApiVo exitAtIdle(Boolean exitAtIdle) {
    this.exitAtIdle = exitAtIdle;
    return this;
  }

  /**
   * Whether to exit when idle.  It is required when parameter [status] is true.
   * @return exitAtIdle
  */
  @ApiModelProperty(value = "Whether to exit when idle.  It is required when parameter [status] is true.")


  public Boolean getExitAtIdle() {
    return exitAtIdle;
  }

  public void setExitAtIdle(Boolean exitAtIdle) {
    this.exitAtIdle = exitAtIdle;
  }

  public SslVpnServerConfigOpenApiVo exitTime(Integer exitTime) {
    this.exitTime = exitTime;
    return this;
  }

  /**
   * Exit time should be within the range of 5–3600(s). It is required when parameter [exitAtIdle] is true.
   * @return exitTime
  */
  @ApiModelProperty(value = "Exit time should be within the range of 5–3600(s). It is required when parameter [exitAtIdle] is true.")


  public Integer getExitTime() {
    return exitTime;
  }

  public void setExitTime(Integer exitTime) {
    this.exitTime = exitTime;
  }

  public SslVpnServerConfigOpenApiVo totalTraffic(Boolean totalTraffic) {
    this.totalTraffic = totalTraffic;
    return this;
  }

  /**
   * Whether to proxy all traffic. It is required when parameter [status] is true.
   * @return totalTraffic
  */
  @ApiModelProperty(value = "Whether to proxy all traffic. It is required when parameter [status] is true.")


  public Boolean getTotalTraffic() {
    return totalTraffic;
  }

  public void setTotalTraffic(Boolean totalTraffic) {
    this.totalTraffic = totalTraffic;
  }


  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    SslVpnServerConfigOpenApiVo sslVpnServerConfigOpenApiVo = (SslVpnServerConfigOpenApiVo) o;
    return Objects.equals(this.status, sslVpnServerConfigOpenApiVo.status) &&
        Objects.equals(this.wanPort, sslVpnServerConfigOpenApiVo.wanPort) &&
        Objects.equals(this.ipPoolStart, sslVpnServerConfigOpenApiVo.ipPoolStart) &&
        Objects.equals(this.ipPoolEnd, sslVpnServerConfigOpenApiVo.ipPoolEnd) &&
        Objects.equals(this.primaryDns, sslVpnServerConfigOpenApiVo.primaryDns) &&
        Objects.equals(this.secondaryDns, sslVpnServerConfigOpenApiVo.secondaryDns) &&
        Objects.equals(this.servicePort, sslVpnServerConfigOpenApiVo.servicePort) &&
        Objects.equals(this.authType, sslVpnServerConfigOpenApiVo.authType) &&
        Objects.equals(this.radiusSetting, sslVpnServerConfigOpenApiVo.radiusSetting) &&
        Objects.equals(this.ldAPSetting, sslVpnServerConfigOpenApiVo.ldAPSetting) &&
        Objects.equals(this.nameLockSetting, sslVpnServerConfigOpenApiVo.nameLockSetting) &&
        Objects.equals(this.ipLockSetting, sslVpnServerConfigOpenApiVo.ipLockSetting) &&
        Objects.equals(this.exitAtIdle, sslVpnServerConfigOpenApiVo.exitAtIdle) &&
        Objects.equals(this.exitTime, sslVpnServerConfigOpenApiVo.exitTime) &&
        Objects.equals(this.totalTraffic, sslVpnServerConfigOpenApiVo.totalTraffic);
  }

  @Override
  public int hashCode() {
    return Objects.hash(status, wanPort, ipPoolStart, ipPoolEnd, primaryDns, secondaryDns, servicePort, authType, radiusSetting, ldAPSetting, nameLockSetting, ipLockSetting, exitAtIdle, exitTime, totalTraffic);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class SslVpnServerConfigOpenApiVo {\n");
    
    sb.append("    status: ").append(toIndentedString(status)).append("\n");
    sb.append("    wanPort: ").append(toIndentedString(wanPort)).append("\n");
    sb.append("    ipPoolStart: ").append(toIndentedString(ipPoolStart)).append("\n");
    sb.append("    ipPoolEnd: ").append(toIndentedString(ipPoolEnd)).append("\n");
    sb.append("    primaryDns: ").append(toIndentedString(primaryDns)).append("\n");
    sb.append("    secondaryDns: ").append(toIndentedString(secondaryDns)).append("\n");
    sb.append("    servicePort: ").append(toIndentedString(servicePort)).append("\n");
    sb.append("    authType: ").append(toIndentedString(authType)).append("\n");
    sb.append("    radiusSetting: ").append(toIndentedString(radiusSetting)).append("\n");
    sb.append("    ldAPSetting: ").append(toIndentedString(ldAPSetting)).append("\n");
    sb.append("    nameLockSetting: ").append(toIndentedString(nameLockSetting)).append("\n");
    sb.append("    ipLockSetting: ").append(toIndentedString(ipLockSetting)).append("\n");
    sb.append("    exitAtIdle: ").append(toIndentedString(exitAtIdle)).append("\n");
    sb.append("    exitTime: ").append(toIndentedString(exitTime)).append("\n");
    sb.append("    totalTraffic: ").append(toIndentedString(totalTraffic)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }
}

